ofpath: Add support for VSCSI, VFC, and SAS
[yaboot.git] / ybin / ofpath
1 #! /bin/sh
2
3 ###############################################################################
4 ##
5 ## ofpath: determine OpenFirmware path from unix device node
6 ## Copyright (C) 2000, 2001, 2002, 2003 Ethan Benson
7 ##
8 ## Portions based on show_of_path.sh:
9 ##
10 ## Copyright (C) 2000 Olaf Hering <olh@suse.de>
11 ##
12 ## This program is free software; you can redistribute it and/or
13 ## modify it under the terms of the GNU General Public License
14 ## as published by the Free Software Foundation; either version 2
15 ## of the License, or (at your option) any later version.
16 ##
17 ## This program is distributed in the hope that it will be useful,
18 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
19 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
20 ## GNU General Public License for more details.
21 ##
22 ## You should have received a copy of the GNU General Public License
23 ## along with this program; if not, write to the Free Software
24 ## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
25 ##
26 ###############################################################################
27
28 PATH="/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin"
29 PRG="${0##*/}"
30 VERSION=1.0.7
31 DEBUG=0
32 export LC_COLLATE=C
33
34 ## --version output.
35 version()
36 {
37 echo \
38 "$PRG $VERSION
39 Written by Ethan Benson
40 Portions based on show_of_path.sh written by Olaf Hering
41
42 Copyright (C) 2000, 2001, 2002, 2003 Ethan Benson
43 Portions Copyright (C) 2000 Olaf Hering
44 This is free software; see the source for copying conditions.  There is NO
45 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
46 }
47
48 ## --help output.
49 usage()
50 {
51 echo \
52 "Usage: $PRG [OPTION]... FILE
53 Find OpenFirmware device path from unix device node.
54
55       --debug                print boring junk only useful for debugging
56   -h, --help                 display this help and exit
57   -V, --version              output version information and exit"
58 }
59
60 ## a small seq replacement, seq is not present on boot/rescue floppies.
61 smallseq()
62 {
63     local v="$1"
64     local n=1
65     echo 1
66     while [ "$v" -gt 1 ] ; do
67         echo "$(($n + 1))"
68         local n="$(($n + 1))"
69         local v="$(($v - 1))"
70     done
71     return 0
72 }
73
74 ## a kludge to replace wc -l, wc is not present on boot/rescue
75 ## floppies. max file is 145 lines, 3 hosts * 16 devs each * 3 lines
76 ## per device, + 1 "Attached Devices:" line.
77 linecount()
78 {
79     if [ $# = 0 ] ; then
80         local file="$(cat)"
81         local v="$file"
82     else
83         local file="$(cat $1)"
84         local v="$file"
85     fi
86
87     if [ -z "$file" ] ; then
88         echo 0
89         return 0
90     fi
91
92     ## use real wc if available
93     if (command -v wc > /dev/null 2>&1) ; then
94         if [ -x `command -v wc` ] ; then
95             lines="$(echo "$file" | wc -l)"
96             if [ $? = 0 ] ; then
97                 echo $lines
98                 unset lines
99                 return 0
100             fi
101         fi
102     fi
103
104     while true ; do
105         for i in `smallseq 145` ; do
106             local b="$(echo "$file" | tail -n $i)"
107             if [ "$v" = "$b" ] ; then
108                 echo "$i"
109                 break 2
110             fi
111         done
112     done
113     return 0
114 }
115
116 ## small tr replacment which handles a specific need of this script.
117 smalltr()
118 {
119     case "$1" in
120         a) echo 1 ;; b) echo 2 ;; c) echo 3 ;; d) echo 4 ;; e) echo 5 ;; f) echo 6 ;;
121         g) echo 7 ;; h) echo 8 ;; i) echo 9 ;; j) echo 10 ;; k) echo 11 ;; l) echo 12 ;;
122         m) echo 13 ;; n) echo 14 ;; o) echo 15 ;; p) echo 16 ;;
123         1) echo a ;; 2) echo b ;; 3) echo c ;; 4) echo d ;; 5) echo e ;;
124         6) echo f ;; 7) echo g ;; 8) echo h ;; 9) echo i ;; 10) echo j ;;
125         11) echo k ;; 12) echo l ;; 13) echo m ;; 14) echo n ;; 15) echo o ;;
126         16) echo p ;;
127     esac
128     return 0
129 }
130
131 ## replacment for grep -l which is not supported by busybox grep.
132 ## echo $(cat..) hack needed because busybox grep barfs with `line too
133 ## long' when fed /proc files.  the for loop is needed since busybox
134 ## grep seems to have somewhat broken regexp support.
135 ## usage: lgrep filename regexp regexp ...
136 lgrep()
137 {
138     local f="$1"
139     shift
140     for i in "$@" ; do
141         echo "$(cat "$f")" | grep -q "$i" && echo "$f" && break
142     done
143     return 0
144 }
145
146 ## if readlink is missing use a kludge
147 if (command -v readlink > /dev/null 2>&1) ; then
148     true
149 else
150     readlink()
151     {
152         local SYMTARGET="$(v=`ls -l "$1" 2>/dev/null` ; echo ${v##*> })"
153         if [ -n "$SYMTARGET" ] ; then
154             echo "$SYMTARGET"
155             return 0
156         else
157             return 1
158         fi
159     }
160 fi
161
162 ## a function to print relevant scsi host path when there is more then
163 ## one.  this function also takes care of stripping off the trailing
164 ## /compatible.
165 printhost()
166 {
167     case "$1" in
168         1)
169         echo "${2%/*}"
170         ;;
171         2)
172         echo "${3%/*}"
173         ;;
174         3)
175         echo "${4%/*}"
176         ;;
177         4)
178         echo "${5%/*}"
179         ;;
180     esac
181     return 0
182 }
183
184 ## this finds information we need on both newworld and oldworld macs.
185 ## mainly what scsi host a disk is attached to.
186 scsiinfo()
187 {
188     ## see if system has scsi at all
189     if [ ! -f /proc/scsi/scsi ] ; then
190         local kver="$(uname -r)"
191         case "$kver" in
192             2.5.*|2.6.*)
193                 if [ -d /sys/bus/scsi/devices -a \
194                     -n "$(ls /sys/bus/scsi/devices 2>/dev/null)" ] ; then
195                     echo 1>&2 "$PRG: /proc/scsi/scsi does not exist"
196                     echo 1>&2 "$PRG: Make sure you compiled your kernel with CONFIG_SCSI_PROC_FS=y"
197                     return 1
198                 fi
199                 ;;
200         esac
201         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
202         return 1
203     fi
204
205     ## first we have to figure out the SCSI ID, have to do that
206     ## anyway [to] find the attached scsi disks = "Direct-Access" and
207     ## stop at sda=1 sdb=2 or whatever count in 3 lines steps
208
209     ## get last letter of device node, ie sda -> a
210     SUBNODE=${DEVNODE##*sd}
211
212     ## turn SUBNODE above into a number starting at 1, ie a -> 1
213     SUBDEV="$(smalltr $SUBNODE)"
214     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SUBNODE=$SUBNODE SUBDEV=$SUBDEV"
215
216     DEVCOUNT=0
217
218     ## copy scsi file into a variable removing "Attached Devices"
219     ## which is the first line. this avoids a lot of
220     ## [incmopatible] crap later, and improves readability.
221
222     ## find number of lines once and recycle that number, to save
223     ## some time (linecount is a bit slow). subtract one line
224     ## to scrap Attached Devices:
225
226     SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
227
228     if [ "$SUBDEV" -gt "$(cat /proc/scsi/scsi | grep Direct-Access | linecount)" ] ; then
229         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
230         return 1
231     fi
232
233     PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
234
235     for i in $(smallseq $(($SCSILINES / 3))) ; do
236
237         ## put every scsi device into one single line
238         DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
239         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVINFO=$DEVINFO"
240
241         ## cut the type field, expect "Direct-Access" later.
242         DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
243         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVTYPE=$DEVTYPE"
244
245         ## get the device LUN.
246         DEVLUN="$(v=$(echo ${DEVINFO##*Lun: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
247         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVLUN=$DEVLUN"
248
249         ## get the device id.
250         DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
251         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVID=$DEVID"
252
253         ## get the device bus.
254         DEVBUS="$(v=$(echo ${DEVINFO##*Channel: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
255         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVBUS=$DEVBUS"
256
257         ## get the scsi host id.
258         DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
259         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVHOST=$DEVHOST"
260
261         if [ "$DEVTYPE" = "Direct-Access" ] || [ "$DEVTYPE" = "Direct-Access-RBC" ] ; then
262             DEVCOUNT="$(($DEVCOUNT + 1))"
263             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVCOUNT=$DEVCOUNT"
264             if [ "$SUBDEV" = "$DEVCOUNT" ] ; then
265                 DEVICE_HOST=$DEVHOST
266                 DEVICE_BUS=$DEVBUS
267                 DEVICE_ID=$DEVID
268                 DEVICE_LUN=$DEVLUN
269                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
270                 break
271             fi
272         fi
273     done
274
275     ## figure out what the scsi driver is, it is /proc/scsi/dirname.
276     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVICE_HOST=$DEVICE_HOST"
277     SCSI_DRIVER="$(x=`ls /proc/scsi/*/$DEVICE_HOST 2>/dev/null | cat` ; y=`echo ${x##*proc/scsi/}` ; echo ${y%%/*})"
278     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_DRIVER=$SCSI_DRIVER"
279
280     ## figure out which host we found.
281     SCSI_HOSTNUMBER="$(v=`ls /proc/scsi/$SCSI_DRIVER/* 2>/dev/null | cat | grep -n "$DEVICE_HOST\>"` ; echo ${v%%:*})"
282     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: SCSI_HOSTNUMBER=$SCSI_HOSTNUMBER"
283
284     return 0
285 }
286
287 read_attr()
288 {
289         local ATTR=$1
290         local START=$2
291         local OLDDIR=$(pwd)
292         local RET
293
294         cd -P "$START"
295         while [[ $PWD != "/" ]]; do
296                 ls $ATTR > /dev/null 2>&1
297                 if [[ $? -eq 0 ]]; then
298                         RET=$(cat $ATTR)
299                         cd $OLDDIR
300                         echo "$RET"
301                         return 0
302                 fi
303                 cd ..
304         done
305
306         cd $OLDDIR
307         echo 1>&2 "$PRG: Cannot find $RET for $DEVICE"
308         exit 1
309 }
310
311 read_dev_attr()
312 {
313         local ATTR=$1
314         local DEVICE="$DEVICE_HOST:$DEVICE_BUS:$DEVICE_ID:$DEVICE_LUN"
315         local START="/sys/bus/scsi/devices/$DEVICE"
316
317         read_attr $ATTR $START
318 }
319
320 read_parent_attr()
321 {
322         local ATTR=$1
323         local DEVICE="$DEVICE_HOST:$DEVICE_BUS:$DEVICE_ID:$DEVICE_LUN"
324         local START="/sys/bus/scsi/devices/$DEVICE/.."
325
326         read_attr $ATTR $START
327 }
328
329 get_vdisk_lun()
330 {
331         local B C D
332         typeset -i B C D
333
334         B=$((0x$DEVICE_ID << 8))
335         C=$((0x$DEVICE_BUS << 5))
336         D=$((0x$DEVICE_LUN))
337
338         local vdiskno vdisk
339         typeset -i vdiskno
340         vdiskno=$((0x8000 | $B | $C | $D ))
341         vdisk=${vdiskno##-}
342
343         vdisk=$(printf "%x" $vdisk)
344         local extrazeroes="000000000000"
345         echo $vdisk$extrazeroes
346 }
347
348 int_to_scsilun()
349 {
350         local lunint=$1
351         local A B C D
352
353         A=$(( ($lunint >> 8) & 0xff ))
354         B=$(($lunint & 0xff))
355         C=$(( ($lunint >> 24) & 0xff ))
356         D=$(( ($lunint >> 16) & 0xff ))
357
358         local lunstr=$(printf "%02x%02x%02x%02x00000000" $A $B $C $D)
359         lunstr=$(echo $lunstr | sed 's/^[0]*//')
360         echo "$lunstr"
361 }
362
363 get_fc_scsilun()
364 {
365         local L=$(echo "$DEVICE_LUN"|gawk '{$1=tolower($1);print}')
366         L=$(printf "%d" $L)
367
368         local fc_lun=$(int_to_scsilun $L)
369         echo "$fc_lun"
370 }
371
372 get_fc_wwpn()
373 {
374         local start_dir=$1
375
376         for f in `find -H $start_dir -maxdepth 2 -name port_name`; do
377                 local wwpn=$(cat $f)
378                 break
379         done
380
381         # strip the leading 0x
382         wwpn=${wwpn:2}
383         echo "$wwpn"
384 }
385
386 scsi_ofpath2()
387 {
388         local DEVSPEC=$(read_parent_attr devspec)
389         local COMPAT=$(cat "/proc/device-tree$DEVSPEC/compatible")
390         local DEVICE_PATH="/sys/bus/scsi/devices/$DEVICE_HOST:$DEVICE_BUS:$DEVICE_ID:$DEVICE_LUN"
391
392         case "$COMPAT" in
393             IBM,v-scsi)
394                 local vdisk=$(get_vdisk_lun)
395                 if [[ $PARTITION = "" ]]; then
396                         echo "$DEVSPEC/disk@$vdisk"
397                 else
398                         echo "$DEVSPEC/disk@$vdisk:$PARTITION"
399                 fi
400                 return 0
401                 ;;
402             IBM,vfc-client)
403                 local vfc_lun=$(get_fc_scsilun)
404                 local wwpn=$(get_fc_wwpn "$DEVICE_PATH/../../fc_remote_ports*")
405                 if [[ $DEVICE_LUN != "0" ]]; then
406                         local vfc_lun=$(get_fc_scsilun)
407                         echo "$DEVSPEC/disk@$wwpn,$vfc_lun"
408                 else
409                         echo "$DEVSPEC/disk@$wwpn"
410                 fi
411                 return 0
412                 ;;
413             *)
414                 ;;
415         esac
416
417         if [[ -d "/proc/device-tree$DEVSPEC/sas" ]]; then
418                 local vendor_id=$(read_parent_attr vendor)
419                 local sas_addr
420
421                 if [[ $vendor_id = "0x1000" ]]; then
422                         sas_addr=$(read_dev_attr sas_address)
423                         sas_addr=${sas_addr##0x}
424                         if [[ $DEVICE_LUN != "0" ]]; then
425                                 local LUN=$(int_to_scsilun $DEVICE_LUN)
426                                 echo "$DEVSPEC/sas/disk@$sas_addr,$LUN"
427                         else
428                                 echo "$DEVSPEC/sas/disk@$sas_addr"
429                         fi
430                         return 0
431                 fi
432
433                 local fwtype="0"
434                 if [[ -e /sys/class/scsi_host/host$DEVICE_HOST/fw_type ]]; then
435                         fwtype=$(cat /sys/class/scsi_host/host$DEVICE_HOST/fw_type)
436                 fi
437
438                 if [[ $fwtype = "1" ]]; then
439                         sas_addr=$(read_dev_attr device_id)
440                         sas_addr=${sas_addr##0x}
441                         if [[ $DEVICE_LUN != "0" ]]; then
442                                 local LUN=$(int_to_scsilun $DEVICE_LUN)
443                                 echo "$DEVSPEC/sas/disk@$sas_addr,$LUN"
444                         else
445                                 echo "$DEVSPEC/sas/disk@$sas_addr"
446                         fi
447                 else
448                         local B T L
449
450                         B=$(echo "$DEVICE_BUS"|gawk '{$1=tolower($1);print}')
451                         B=$(printf "%d" $B)
452                         T=$(echo "$DEVICE_ID"|gawk '{$1=tolower($1);print}')
453                         T=$(printf "%d" $T)
454                         L=$(echo "$DEVICE_LUN"|gawk '{$1=tolower($1);print}')
455                         L=$(printf "%d" $L)
456
457                         sas_addr=$(( ($B << 16) | ($T << 8) | $L ))
458                         if [[ $DEVICE_LUN != "0" ]]; then
459                                 printf "%s/sas/disk@%x,%x\n" $DEVSPEC $sas_addr $DEVICE_LUN
460                         else
461                                 printf "%s/sas/disk@%x\n" $DEVSPEC $sas_addr
462                         fi
463                 fi
464                 return 0
465         fi
466
467         echo 1>&2 "$PRG: Driver: $SCSI_DRIVER is not supported"
468         return 1
469 }
470
471 ## generic function that can find OF device paths for scsi devices,
472 ## must be run after scsiinfo().
473 scsi_ofpath()
474 {
475     case "$SCSI_DRIVER" in
476         aic7xxx)
477             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
478                         lgrep "$i" "^ADPT" "^pci900[45]" "^pciclass,01000" ; done)"
479             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
480             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
481             ;;
482         sym53c8xx)
483             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
484                         lgrep "$i" "^Symbios" "^pci1000" "^pciclass,01000" ; done)"
485             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
486             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
487             ;;
488         mesh)
489             HOST_LIST="$(for i in `find /proc/device-tree -name compatible` ; do
490                         lgrep "$i" "mesh" ; done)"
491             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
492             echo "${DEVICE_PATH##*device-tree}/@$DEVICE_ID:$PARTITION"
493             ;;
494         ata_k2|sata_svw)
495             #Not all G5 device trees have a compatible "k2-sata" node 
496             #per channel use parent
497             HOST_LIST="$(for i in `find /proc/device-tree -name compatible ` ; do
498                         lgrep "$i" "k2-s-ata" ; done | sort)"
499             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
500             K2_DEVICE_ID=0
501             while [ "$DEVICE_PATH" = "" ] ; do
502                 SCSI_HOSTNUMBER=`expr $SCSI_HOSTNUMBER - 1`
503                 let "K2_DEVICE_ID += 1"
504                 DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
505             done
506             echo "${DEVICE_PATH##*device-tree}/k2-sata@$K2_DEVICE_ID/disk@0:$PARTITION"
507             ;;
508         usb-storage)
509             HOST_LIST="$(for i in `find /proc/device-tree -name name | grep usb` ; do
510                         lgrep "$i" "disk" ; done)"
511             DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
512             echo "${DEVICE_PATH##*device-tree}:$PARTITION"
513             ;;
514         sbp2|"")
515             # sbp-2 driver may not have a dir in /proc/scsi
516             HOST_LIST="$(for i in `find /proc/device-tree -name name` ; do
517                         lgrep "$i" "sbp-2" ; done)"
518             if [ "$HOST_LIST" = "" ] ; then
519                 scsi_ofpath2
520             else
521                 if [ "$SCSI_HOSTNUMBER" = "" ] ; then
522                         SCSI_HOSTNUMBER=1
523                 fi
524                 DEVICE_PATH="$(printhost $SCSI_HOSTNUMBER $HOST_LIST)"
525                 echo "${DEVICE_PATH##*device-tree}/disk@0:$PARTITION"
526             fi
527             ;;
528         *)
529             echo 1>&2 "$PRG: Driver: $SCSI_DRIVER is not supported"
530             return 1
531             ;;
532     esac
533     return 0
534 }
535
536 ide_ofpath()
537 {
538     if [ ! -L "/proc/ide/$DEVNODE" ] ; then
539         echo 1>&2 "$PRG: /dev/$DEVNODE: Device not configured"
540         return 1
541     fi
542
543     local IDEBUS="$(v=`readlink /proc/ide/$DEVNODE` ; echo ${v%%/*} )"
544     if [ -z "$IDEBUS" ] ; then
545         echo 1>&2 "$PRG: BUG: IDEBUS == NULL"
546         return 1
547     fi
548
549     case "$(uname -r)" in
550         2.5.*|2.6.0*|2.6.1|2.6.1-*|2.6.2|2.6.2-*)
551             echo 1>&2 "$PRG: Linux kernel `uname -r` is not supported"
552             return 1
553             ;;
554         2.6.*|2.7.*)
555             if ! (grep -q '.* .* sysfs ' /proc/mounts 2> /dev/null) ; then
556                 echo 1>&2 "$PRG: sysfs must be mounted for ofpath to support this system"
557                 return 1
558             fi
559             local SYS="$(m=`grep '.* .* sysfs ' /proc/mounts | head -n 1` ; echo `d=${m#* };echo ${d%% *}`)"
560             if [ -z "$SYS" -o ! -d "$SYS" ] ; then
561                 echo 1>&2 "$PRG: Unable to determine sysfs mountpoint"
562                 return 1
563             fi
564             local OF1275IDE="${SYS}/block/${DEVNODE}/device/../../devspec"
565             ;;
566         *)
567             local OF1275IDE="/proc/ide/$IDEBUS/devspec"
568             ;;
569     esac
570
571     if [ ! -f "$OF1275IDE" ] ; then
572         case "$(cat /proc/device-tree/model)" in
573             PowerMac3*|PowerMac4*|PowerMac5*|PowerMac6*|PowerMac7*|RackMac*)
574                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
575                 if [ -z "$CDROM" ] ; then
576                     echo 1>&2 "$PRG: WARNING: Your kernel is too old for proper support, device may be innaccurate."
577                     echo "ultra2:$PARTITION"
578                 else
579                     echo "cd:$PARTITION"
580                 fi
581                 ;;
582             *)
583                 local CDROM="$(grep "^drive name:" /proc/sys/dev/cdrom/info 2> /dev/null | grep $DEVNODE)"
584                 if [ -z "$CDROM" ] ; then
585                     if [ "$DEVNODE" = hda ] ; then
586                         echo "hd:$PARTITION"
587                     else
588                         echo "ultra1:$PARTITION"
589                     fi
590                 else
591                     echo "cd:$PARTITION"
592                 fi
593                 ;;
594         esac
595     else
596         local DEVSPEC="$(cat $OF1275IDE)"
597         [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: DEVSPEC=$DEVSPEC"
598         if [ -z "$DEVSPEC" ] ; then
599             echo 1>&2 "$PRG: KERNEL BUG: $OF1275IDE exists, but is empty"
600             return 1
601         fi
602
603         if [ ! -f "/proc/ide/${IDEBUS}/channel" ] ; then
604             echo 1>&2 "$PRG: KERNEL BUG: /proc/ide/${IDEBUS}/channel does not exist"
605             return 1
606         fi
607
608         case "$(cat /proc/device-tree${DEVSPEC}/device_type 2> /dev/null)" in
609             ide|ata)
610                 local MASTER="/disk@0"
611                 local SLAVE="/disk@1"
612                 ;;
613             pci-ide|pci-ata)
614                 local MASTER="/@$(cat /proc/ide/${IDEBUS}/channel)/disk@0"
615                 local SLAVE="/@$(cat /proc/ide/${IDEBUS}/channel)/disk@1"
616                 ;;
617             scsi) ## some lame controllers pretend they are scsi, hopefully all kludges are created equal.
618                 local MASTER="/@$(($(cat /proc/ide/${IDEBUS}/channel) * 2 + 0))"
619                 local SLAVE="/@$(($(cat /proc/ide/${IDEBUS}/channel) * 2 + 1))"
620                 ;;
621             spi)
622                 local MASTER="/disk@$(cat /proc/ide/${IDEBUS}/channel),0"
623                 local SLAVE="/disk@$(cat /proc/ide/${IDEBUS}/channel),1"
624                 ;;
625             *)
626                 echo 1>&2 "$PRG: Unsupported IDE device type: \"$(cat /proc/device-tree${DEVSPEC}/device_type 2> /dev/null)\""
627                 return 1
628                 ;;
629         esac
630
631         case "$DEVNODE" in
632             hda|hdc|hde|hdg|hdi|hdk|hdm|hdo)
633                 echo "${DEVSPEC}${MASTER}:$PARTITION"
634                 return 0
635                 ;;
636             hdb|hdd|hdf|hdh|hdj|hdl|hdn|hdp)
637                 echo "${DEVSPEC}${SLAVE}:$PARTITION"
638                 return 0
639                 ;;
640             *)
641                 echo 1>&2 "$PRG: /dev/$DEVNODE is not supported"
642                 return 1
643                 ;;
644         esac
645     fi
646 }
647
648 ## figure out the OpenFirmware device path for newworld macs.
649 ## sd* scsi disks , hd* ide disks.
650 newworld()
651 {
652     case "$DEVNODE" in
653         sd*)
654             ## use common scsiinfo function to get info we need.
655             scsiinfo || return 1
656
657             ## now we have the data for /@$DEVID:$PARTITION
658             ## find the actual OF path.
659             scsi_ofpath || return 1
660             ;;
661         hd*)
662             ide_ofpath || return 1
663             ;;
664         *)
665             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
666             return 1
667             ;;
668     esac
669     return 0
670 }
671
672 oldworld()
673 {
674     ## for some reason 2.4 kernels put OF aliases in aliases@0/ instead of plain aliases/
675     if [ -d "/proc/device-tree/aliases" ] ; then
676         local ALIASES="aliases"
677     elif [ -d "/proc/device-tree/aliases@0" ] ; then
678         local ALIASES="aliases@0"
679     else
680         echo 1>&2 "$PRG: Cannot find OpenFirmware aliases directory in /proc/device-tree/"
681         return 1
682     fi
683
684     local MODEL="$(cat /proc/device-tree/compatible)"
685     [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: Oldworld subarch: $MODEL"
686
687     case "$MODEL" in
688         AAPL,7300*|AAPL,7500*|AAPL,8500*|AAPL,9500*|AAPL,\?\?\?\?*)
689             case "$DEVNODE" in
690                 sd*)
691                 scsiinfo || return 1
692                 case "$SCSI_DRIVER" in
693                     mesh)
694                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITION
695                     ;;
696                     53c94)
697                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
698                     ;;
699                     *)
700                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
701                     return 1
702                     ;;
703                 esac
704                 ;;
705                 *)
706                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
707                 return 1
708                 ;;
709             esac
710             ;;
711         AAPL,e407*)
712             case "$DEVNODE" in
713                 sd*)
714                 scsiinfo || return 1
715                 case "$SCSI_DRIVER" in
716                     mesh)
717                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
718                     ;;
719                     *)
720                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
721                     return 1
722                     ;;
723                 esac
724                 ;;
725                 hda*)
726                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@0:$PARTITION
727                 ;;
728                 hdb*)
729                 echo $(cat /proc/device-tree/$ALIASES/ata)/ATA-Disk\@1:$PARTITION
730                 ;;
731                 hd*)
732                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
733                 ;;
734             esac
735             ;;
736         AAPL,e826*)
737             case "$DEVNODE" in
738                 sd*)
739                 scsiinfo || return 1
740                 case "$SCSI_DRIVER" in
741                     mesh)
742                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
743                     ;;
744                     *)
745                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
746                     return 1
747                     ;;
748                 esac
749                 ;;
750                 hda*)
751                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@0:$PARTITION
752                 ;;
753                 hdb*)
754                 echo $(cat /proc/device-tree/$ALIASES/ata)/ata-disk\@1:$PARTITION
755                 ;;
756                 hd*)
757                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
758                 ;;
759             esac
760             ;;
761         AAPL,Gossamer*|AAPL,PowerMac\ G3*)
762             case "$DEVNODE" in
763                 sd*)
764                 scsiinfo || return 1
765                 case "$SCSI_DRIVER" in
766                     mesh)
767                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITION
768                     ;;
769                     *)
770                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
771                     return 1
772                     ;;
773                 esac
774                 ;;
775                 hda*)
776                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@0:$PARTITION
777                 ;;
778                 hdb*)
779                 echo $(cat /proc/device-tree/$ALIASES/ide0)/ata-disk\@1:$PARTITION
780                 ;;
781                 hdc*)
782                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@0:$PARTITION
783                 ;;
784                 hdd*)
785                 echo $(cat /proc/device-tree/$ALIASES/ide1)/ata-disk\@1:$PARTITION
786                 ;;
787                 hd*)
788                 echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
789                 ;;
790             esac
791             ;;
792         AAPL,PowerBook1998*)
793             if [ -f  /proc/device-tree/$ALIASES/ata0 ] ; then
794                 local ATA0=ata0
795             else
796                 local ATA0=ide0
797             fi
798             if [ -f  /proc/device-tree/$ALIASES/ata1 ] ; then
799                 local ATA1=ata1
800             else
801                 local ATA1=bay-ata1
802             fi
803             case "$DEVNODE" in
804                 sd*)
805                 scsiinfo || return 1
806                 case "$SCSI_DRIVER" in
807                     mesh)
808                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
809                     ;;
810                     *)
811                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
812                     return 1
813                     ;;
814                 esac
815                 ;;
816                 hda*)
817                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@0:$PARTITION
818                 ;;
819                 hdb*)
820                 echo $(cat /proc/device-tree/$ALIASES/$ATA0)/ata-disk\@1:$PARTITION
821                 ;;
822                 hdc*)
823                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@0:$PARTITION
824                 ;;
825                 hdd*)
826                 echo $(cat /proc/device-tree/$ALIASES/$ATA1)/atapi-disk\@1:$PARTITION
827                 ;;
828                 *)
829                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
830                 return 1
831                 ;;
832             esac
833             ;;
834         AAPL,3400/2400*)
835             case "$DEVNODE" in
836                 sd*)
837                 scsiinfo || return 1
838                 case "$SCSI_DRIVER" in
839                     mesh)
840                     echo $(cat /proc/device-tree/$ALIASES/scsi-int)/sd\@$DEVICE_ID:$PARTITON
841                     ;;
842                     53c94)
843                     echo $(cat /proc/device-tree/$ALIASES/scsi)/sd\@$DEVICE_ID:$PARTITON
844                     ;;
845                     *)
846                     echo 1>&2 "$PRG: Driver $SCSI_DRIVER is not supported"
847                     return 1
848                     ;;
849                 esac
850                 ;;
851                 hda*)
852                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@0:$PARTITION
853                 ;;
854                 hdb*)
855                 echo $(cat /proc/device-tree/$ALIASES/ata0)/ata-disk\@1:$PARTITION
856                 ;;
857                 hdc*)
858                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@0:$PARTITION
859                 ;;
860                 hdd*)
861                 echo $(cat /proc/device-tree/$ALIASES/ata1)/atapi-disk\@1:$PARTITION
862                 ;;
863                 hde*)
864                 echo $(cat /proc/device-tree/$ALIASES/ata2):$PARTITION
865                 ;;
866                 hdf*)
867                 echo $(cat /proc/device-tree/$ALIASES/ata3):$PARTITION
868                 ;;
869                 *)
870                 echo 1>&2 "$PRG: Unsupported device: /dev/$DEVNODE"
871                 return 1
872                 ;;
873             esac
874             ;;
875         *)
876             echo 1>&2 "$PRG: This machine is not supported: $MODEL"
877             return 1
878             ;;
879     esac
880     return 0
881 }
882
883 ## find OpenFirmware device path for IBM CHRP hardware (scsi only)
884 chrp()
885 {
886     case "$DEVNODE" in
887         sd*)
888
889             ## use common scsiinfo function to get info we need.
890             scsiinfo || return 1
891
892             ## now we have the data for /@$DEVID:$PARTITION
893             ## find the actual OF path.
894             scsi_ofpath || return 1
895             ;;
896         *)
897             echo 1>&2 "$PRG: Device: /dev/$DEVNODE is not supported"
898             return 1
899             ;;
900     esac
901     return 0
902 }
903
904 ## If we get lame devfs name, we need to make it foad
905 ckdevfs()
906 {
907     case "$1" in
908         /dev/ide/*|/dev/scsi/*|/dev/discs/*)
909         return 0
910         ;;
911         *)
912         return 1
913         ;;
914     esac
915 }
916
917 ## convert devfs names into normal short ones, written by Tom Rini.
918 fixdevfs()
919 {
920     ## get partition number, if any
921     local PARTNUM="${1##*[a-z]}"
922     ## Find the bus type.
923     local TYPE="$(v=${1#/dev/} ; echo ${v%/host*})"
924     ## Find the host number.
925     local HOST="$(v=${1#/dev/*/host} ; echo ${v%/bus*})"
926     ## Find the bus number.
927     local BUS="$(v=${1#/dev/*/bus} ; echo ${v%/tar*})"
928     ## Find the target.
929     local TARGET="$(v=${1#/dev/*/target} ; echo ${v%/lun*})"
930
931     case "$TYPE" in
932         ide)
933         case "$HOST" in
934             0)
935             case "$TARGET" in
936                 0)
937                 local DEV=hda
938                 ;;
939                 1)
940                 local DEV=hdb
941                 ;;
942             esac
943             ;;
944             1)
945             case "$TARGET" in
946                 0)
947                 local DEV=hdc
948                 ;;
949                 1)
950                 local DEV=hdd
951                 ;;
952             esac
953             ;;
954             *)
955                 echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
956                 return 1
957         esac
958         local DEV="${DEV}${PARTNUM}"
959         echo "/dev/$DEV"
960         return 0
961         ;;
962         scsi)
963         local LUN="$(v=${1#/dev/*/lun} ; echo ${v%/*})"
964
965         ## In this case, we need to figure out what number our device is
966         local DEVCOUNT=0
967
968         ## copy scsi file into a variable removing "Attached Devices"
969         ## which is the first line. this avoids a lot of
970         ## [incmopatible] crap later, and improves readability.
971
972         ## find number of lines once and recycle that number, to save
973         ## some time (linecount is a bit slow). subtract one line
974         ## to scrap Attached Devices:
975
976         local SCSILINES="$(($(linecount /proc/scsi/scsi) - 1))"
977         local PROCSCSI="$(cat /proc/scsi/scsi | tail -n $SCSILINES)"
978
979         for i in $(smallseq $(($SCSILINES / 3))) ; do
980
981             ## put every scsi device into one single line
982             local DEVINFO="$(echo "$PROCSCSI" | head -n $(($i * 3)) | tail -n 3)"
983             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVINFO=$DEVINFO"
984
985             ## cut the type field, expect "Direct-Access" later.
986             local DEVTYPE="$(v=$(echo ${DEVINFO##*Type: }) ; echo ${v%% *})"
987             [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVTYPE=$DEVTYPE"
988
989             if [ "$DEVTYPE" = "Direct-Access" ] || [ "$DEVTYPE" = "Direct-Access-RBC" ] ; then
990                 ## Lets find out some more information
991                 ## get the device id.
992                 local DEVID="$(v=$(echo ${DEVINFO##*Id: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
993                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVID=$DEVID"
994
995                 ## get the device lun.
996                 local DEVLUN="$(v=$(echo ${DEVINFO##*Lun: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
997                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVLUN=$DEVLUN"
998
999                 ## get the device channel.
1000                 local DEVCHAN="$(v=$(echo ${DEVINFO##*Channel: }) ; n=$(echo ${v%% *}) ; echo ${n#*0})"
1001                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCHAN=$DEVCHAN"
1002
1003                 ## get the scsi host id.
1004                 local DEVHOST="$(v=$(echo ${DEVINFO##*Host: scsi}) ; echo ${v%% *})"
1005                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVHOST=$DEVHOST"
1006
1007                 local DEVCOUNT="$(($DEVCOUNT + 1))"
1008                 [ "$DEBUG" = 1 ] && echo 1>&2 "$PRG: DEBUG: fixdevfs: DEVCOUNT=$DEVCOUNT"
1009                 if [ "$DEVHOST" = "$HOST" -a "$DEVCHAN" = "$BUS" -a \
1010                     "$DEVID" = "$TARGET" -a "$DEVLUN" = "$LUN" ] ; then
1011                     local DEV="sd$(smalltr $DEVCOUNT)${PARTNUM}"
1012                     echo "/dev/$DEV"
1013                     return 0
1014                 fi
1015             fi
1016         done
1017         echo 1>&2 "$PRG: $1: Unable to translate this device, try again without devfs."
1018         return 1
1019         ;;
1020         *)
1021         echo 1>&2 "$PRG: Unknown bus $TYPE"
1022         return 1
1023         ;;
1024     esac
1025     ## we should never get here
1026     return 1
1027 }
1028
1029 ## make sure that find, head and tail can be found.  otherwise the
1030 ## script will silently give bogus paths.  these are the only /usr/*
1031 ## utilities this script depends on.
1032 checkutils()
1033 {
1034     if command -v find > /dev/null 2>&1 ; then
1035         [ -x `command -v find` ] || FAIL=1 ; else FAIL=1 ; fi
1036     if command -v head > /dev/null 2>&1 ; then
1037         [ -x `command -v head` ] || FAIL=1 ; else FAIL=1 ; fi
1038     if command -v tail > /dev/null 2>&1 ; then
1039         [ -x `command -v tail` ] || FAIL=1 ; else FAIL=1 ; fi
1040
1041     if [ "$FAIL" = 1 ] ; then
1042         echo 1>&2 "$PRG: \`find', \`head', or \`tail' could not be found, aborting."
1043         return 1
1044     else
1045         return 0
1046     fi
1047 }
1048
1049 ## parse command line switches.
1050 if [ $# != 0 ] ; then
1051     while true ; do
1052         case "$1" in
1053             -V|--version)
1054                 version
1055                 exit 0
1056                 ;;
1057             -h|--help)
1058                 usage
1059                 exit 0
1060                 ;;
1061             --debug)
1062                 DEBUG=1
1063                 shift
1064                 ;;
1065             -*)
1066                 echo 1>&2 "$PRG: unrecognized option \`$1'"
1067                 echo 1>&2 "$PRG: Try \`$PRG --help' for more information."
1068                 exit 1
1069                 ;;
1070             "")
1071                 echo 1>&2 "$PRG: You must specify a filename"
1072                 echo 1>&2 "Try \`$PRG --help' for more information."
1073                 exit 1
1074                 ;;
1075             *)
1076                 device="$1"
1077                 break
1078                 ;;
1079         esac
1080     done
1081 else
1082     echo 1>&2 "$PRG: You must specify a /dev device"
1083     echo 1>&2 "Try \`$PRG --help' for more information."
1084     exit 1
1085 fi
1086
1087 ## check that FILE is a block device and exists.
1088 if [ ! -e "$device" ] ; then
1089     echo 1>&2 "$PRG: $device: No such file or directory"
1090     exit 1
1091 elif [ ! -b "$device" ] ; then
1092     echo 1>&2 "$PRG: $device is not a block device"
1093     exit 1
1094 fi
1095
1096 ## check that we are running on a GNU/Linux system, OSX/BSD does not
1097 ## have the same /proc stuff
1098 if [ `uname -s` != Linux ] ; then
1099     echo 1>&2 "$PRG: This utility will only work with GNU/Linux"
1100     exit 1
1101 fi
1102
1103 ## check for ppc, i think uname -m is safe for this...
1104 if [ `uname -m` != ppc -a `uname -m` != ppc64 ] ; then
1105     echo 1>&2 "$PRG: This utility will only work on PowerPC hardware"
1106     exit 1
1107 fi
1108
1109 ## ofpath cannot live without procfs
1110 if [ ! -f /proc/uptime ] ; then
1111     echo 1>&2 "$PRG: This utility requires the /proc filesystem"
1112     exit 1
1113 fi
1114
1115 ## check for retarded devfs names and tell them to foad.
1116 if ckdevfs "$device" ; then
1117     device="$(fixdevfs $device)" || exit 1
1118 fi
1119
1120 ## check for newworld mac. use cat hack due to /proc wierdness.
1121 if [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = NewWorld ] ; then
1122     SUBARCH=NewWorld
1123 elif [ "$(v=`cat /proc/cpuinfo 2>/dev/null | grep pmac-generation` ; echo ${v##*:[ ]})" = OldWorld ] ; then
1124     SUBARCH=OldWorld
1125 elif (cat /proc/cpuinfo 2>/dev/null | grep ^motherboard | grep -q AAPL) ; then
1126     SUBARCH=OldWorld
1127 elif (cat /proc/cpuinfo 2> /dev/null | grep ^machine | grep -q 'CHRP IBM') ; then
1128     SUBARCH=CHRP
1129 elif (cat /proc/cpuinfo 2>/dev/null | grep ^machine | grep -q 'CHRP Pegasos') ; then
1130     SUBARCH=Pegasos
1131 else
1132     echo 1>&2 "$PRG: This machine is not yet supported"
1133     exit 1
1134 fi
1135
1136 ## make sure /proc/device-tree exists
1137 if [ ! -d /proc/device-tree ] ; then
1138     echo 1>&2 "$PRG: /proc/device-tree does not exist"
1139     echo 1>&2 "$PRG: Make sure you compiled your kernel with CONFIG_PROC_DEVICETREE=y"
1140     exit 1
1141 fi
1142
1143 ## make sure we have what we need.
1144 checkutils || exit 1
1145
1146 ## get the base device node and scrap /dev/ ie /dev/hda2 -> hda
1147 DEVICE="${device##*/}"
1148 DEVNODE="${DEVICE%%[0-9]*}"
1149 PARTITION="${DEVICE##*[a-z]}"
1150
1151 ## use appropriate search for right sub arch.
1152 case "$SUBARCH" in
1153     # Pegasos OF seems to be NewWorld-ish enough to cope with this.
1154     NewWorld|Pegasos)
1155         newworld || exit 1
1156         ;;
1157     OldWorld)
1158         oldworld || exit 1
1159         ;;
1160     CHRP)
1161         chrp || exit 1
1162         ;;
1163 esac
1164
1165 exit 0